ifeq ($(COMPILER),gnu)
#
# Dependencies
#

include make.dep

make.dep:
	./makedep.pl > $@

# Depend on dynamic intermediate output (header files used by  project code need to be in make.dep correctly for everything to work)

#
# Compilation (MSVC or intel compiler)
#
$(HLCSG_OUTDIR)/%$(OBJEXT) : $(HLCSG_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(HLCSG_DEFINES) -o$@ $<

$(HLCSG_OUTDIR)/%$(OBJEXT) : $(COMMON_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(HLCSG_DEFINES) -o$@ $<

$(HLBSP_OUTDIR)/%$(OBJEXT) : $(HLBSP_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(HLBSP_DEFINES) -o$@ $<

$(HLBSP_OUTDIR)/%$(OBJEXT) : $(COMMON_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(HLBSP_DEFINES) -o$@ $<

$(HLVIS_OUTDIR)/%$(OBJEXT) : $(HLVIS_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(HLVIS_DEFINES) -o$@ $<

$(HLVIS_OUTDIR)/%$(OBJEXT) : $(COMMON_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(HLVIS_DEFINES) -o$@ $<

$(HLRAD_OUTDIR)/%$(OBJEXT) : $(HLRAD_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(HLRAD_DEFINES) -o$@ $<

$(HLRAD_OUTDIR)/%$(OBJEXT) : $(COMMON_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(HLRAD_DEFINES) -o$@ $<

$(RIPENT_OUTDIR)/%$(OBJEXT) : $(RIPENT_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(RIPENT_DEFINES) -o$@ $<

$(RIPENT_OUTDIR)/%$(OBJEXT) : $(COMMON_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(RIPENT_DEFINES) -o$@ $<

$(NETVIS_OUTDIR)/%$(OBJEXT) : $(NETVIS_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(NETVIS_DEFINES) -o$@ $<

$(NETVIS_OUTDIR)/%$(OBJEXT) : $(HLVIS_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(NETVIS_DEFINES) -o$@ $<

$(NETVIS_OUTDIR)/%$(OBJEXT) : $(COMMON_SRCDIR)/%.cpp
	$(CPP) $(INCLUDEDIRS) $(CPPFLAGS) $(DEFINES) $(NETVIS_DEFINES) -o$@ $<


#
# Executable
#

$(HLCSG) : $(OUTDIR) $(HLCSG_OUTDIR) $(HLCSG_INPUT) $(HLCSG_OUTPUT)
	$(CPP) $(EXE_FLAGS) $(DEFAULT_LIBRARIES) $(HLCSG_LIBRARIES) $(HLCSG_OUTPUT) -o$@

$(HLBSP) : $(OUTDIR) $(HLBSP_OUTDIR) $(HLBSP_INPUT) $(HLBSP_OUTPUT)
	$(CPP) $(EXE_FLAGS) $(DEFAULT_LIBRARIES) $(HLBSP_LIBRARIES) $(HLBSP_OUTPUT) -o$@

$(HLVIS) : $(OUTDIR) $(HLVIS_OUTDIR) $(HLVIS_INPUT) $(HLVIS_OUTPUT)
	$(CPP) $(EXE_FLAGS) $(DEFAULT_LIBRARIES) $(HLVIS_LIBRARIES) $(HLVIS_OUTPUT) -o$@

$(HLRAD) : $(OUTDIR) $(HLRAD_OUTDIR) $(HLRAD_INPUT) $(HLRAD_OUTPUT)
	$(CPP) $(EXE_FLAGS) $(DEFAULT_LIBRARIES) $(HLRAD_LIBRARIES) $(HLRAD_OUTPUT) -o$@

$(RIPENT) : $(OUTDIR) $(RIPENT_OUTDIR) $(RIPENT_INPUT) $(RIPENT_OUTPUT)
	$(CPP) $(EXE_FLAGS) $(DEFAULT_LIBRARIES) $(RIPENT_LIBRARIES) $(RIPENT_OUTPUT) -o$@

$(NETVIS) : $(OUTDIR) $(NETVIS_OUTDIR) $(NETVIS_INPUT) $(NETVIS_OUTPUT)
	$(CPP) $(EXE_FLAGS) $(DEFAULT_LIBRARIES) $(NETVIS_LIBRARIES) $(NETVIS_OUTPUT) -o$@


# COMPILER==gnu
endif
